"""Change cpu hours type from float to time

Revision ID: 2dfdf90504a0
Revises: 4fba6a441927
Create Date: 2024-07-16 08:53:45.708625

"""

from collections.abc import Sequence

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision: str = "2dfdf90504a0"
down_revision: str | None = "4fba6a441927"
branch_labels: str | Sequence[str] | None = None
depends_on: str | Sequence[str] | None = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column("workflow_execution", "cpu_hours", new_column_name="old_cpu_hours", existing_type=mysql.FLOAT())
    op.add_column("workflow_execution", sa.Column("cpu_days", mysql.SMALLINT(unsigned=True), nullable=False))
    op.add_column("workflow_execution", sa.Column("cpu_hours", mysql.TIME(fsp=3), nullable=False))
    op.get_bind().execute(
        sa.sql.text(
            "UPDATE workflow_execution SET cpu_days=FLOOR(old_cpu_hours / 24), cpu_hours=SEC_TO_TIME(MOD(old_cpu_hours, 24)*3600)"
        )
    )
    op.drop_column("workflow_execution", "old_cpu_hours")
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.alter_column("workflow_execution", "cpu_hours", new_column_name="old_cpu_hours", existing_type=mysql.TIME(fsp=3))
    op.add_column("workflow_execution", sa.Column("cpu_hours", mysql.FLOAT(), nullable=False))
    op.get_bind().execute(
        sa.sql.text("UPDATE workflow_execution SET cpu_hours=cpu_days*24+TIME_TO_SEC(old_cpu_hours)/3600")
    )
    op.drop_column("workflow_execution", "cpu_days")
    op.drop_column("workflow_execution", "old_cpu_hours")
    # ### end Alembic commands ###
